//=====================================================================//
//                                                                     //
//  ե̾ : ImageFileIO.h                                         //
//         : ppm (Portable PixMap), pgm (Portable GrayMap)ե //
//               ϥǡɤ߹ߤӽϥǡ񤭽Ф  //
//               Ԥ                                                //
//       : 2004. 2. 11 ¼  (Computer Graphics Lab.)        //
//               2014. 9. 5   (Computer VIsion Lab.)             //
//               2014. 11. 24  ľ                                //
//                                                                     //
//=====================================================================//
#ifndef _IMAGEFILEIO_H_
#define _IMAGEFILEIO_H_ 1

// ¤ RGB
struct RGB {
    int iRed;
    int iGreen;
    int iBlue;
};

// RGB ѥ᡼
#define RED   0
#define GREEN 1
#define BLUE  2

//---------------------------------------------------------------------//
// void GetAxisFromIndex(int iWidth, int iIndex, int * iX, int * iY)   //
//        : Υǥå飲ɸ               //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                     //
// []                                                              //
// iWidth       : ϡ˲ʲǿ                           //
// iIndex       : ϡ˥ǥå                                 //
// iX           : ʽϡ˲κɸʲǿ                       //
// iY           : ʽϡ˽κɸʲǿ                       //
//---------------------------------------------------------------------//
void GetAxisFromIndex(int iWidth, int iIndex, int * iX, int * iY);

//---------------------------------------------------------------------//
// void GetIndexFromAxis(int iWidth, int iX, int iY, int * iIndex)     //
//        : ɸ飱Υǥå               //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                     //
// []                                                              //
// iWidth       : ϡ˲ʲǿ                           //
// iX           : ϡ˲κɸʲǿ                       //
// iY           : ϡ˽κɸʲǿ                       //
// iIndex       : ʽϡ˥ǥå                                 //
//---------------------------------------------------------------------//
void GetIndexFromAxis(int iWidth, int iX, int iY, int * iIndex);

//---------------------------------------------------------------------//
// struct RGB * ReadPpm(int * iWidth, int * iHeight, int * iMaxValue)  //
//        : PPMեɤ߹                                  //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                     //
// []                                                            //
//              : ([ǿ][RGB])PPMΥǡ               //
//                ǿ=iWidth * iHeight                              //
// []                                                              //
// iWidth       : ʲǿ                                   //
// iHeight      : ι⤵ʲǿ                                 //
// iMaxValue    : γƲǤRGBκ                            //
//---------------------------------------------------------------------//
struct RGB * ReadPpm(int * iWidth, int * iHeight, int * iMaxValue);

//--------------------------------------------------------------------//
// void FreePpm(struct RGB * pRGBOutputData)                          //
//        : PPMβǡ¸Ƥΰγ     //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                    //
// []                                                             //
// pRGBOutputData : ([ǿ][RGB])PPMΥǡ            //
//--------------------------------------------------------------------//
void FreePpm(struct RGB * pRGBOutputData);

//--------------------------------------------------------------------//
// void WritePpm(struct RGB * pRGBOutputData, int iWidth,             //
//               int iHeight, int iMaxValue)                          //
//        : PPMեؽ񤭽Ф                                 //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                    //
// []                                                             //
// piRGBOutputData : ([ǿ][RGB])PPMΥǡ           //
//                ǿ=iWidth * iHeight                             //
// iWidth       : ʲǿ                                  //
// iHeight      : ι⤵ʲǿ                                //
// iMaxValue    : γƲǤRGBκ                           //
//--------------------------------------------------------------------//
void WritePpm(struct RGB * pRGBOutputData, int iWidth, int iHeight, int iMaxValue);

//--------------------------------------------------------------------//
// int * ReadPgm(int * iWidth, int * iHeight, int * iMaxValue)    //
//        : PGMեɤ߹                                 //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                    //
// []                                                           //
//              : ([ǿ])PGMΥǡ                   //
//                ǿ=iWidth * iHeight                             //
// []                                                             //
// iWidth       : ʲǿ                                  //
// iHeight      : ι⤵ʲǿ                                //
// iMaxValue    : βͤκ                                //
//--------------------------------------------------------------------//
int * ReadPgm(int * iWidth, int * iHeight, int * iMaxValue);

//---------------------------------------------------------------------//
// void FreePgm(int * piOutputData)                                    //
//        : PGMβǡ¸Ƥΰγ      //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                     //
// []                                                              //
// piOutputData : ([ǿ][RGB])PGMΥǡ               //
//---------------------------------------------------------------------//
void FreePgm(int * piOutputData);

//---------------------------------------------------------------------//
// void WritePgm(int * piOutputData, int iWidth,                       //
//               int iHeight, int iMaxValue)                           //
//        : PGMեؽ񤭽Ф                                  //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                     //
// []                                                              //
// piInputData  : ([ǿ])PGMΥǡ                    //
//                ǿ=iWidth * iHeight                              //
// iWidth       : ʲǿ                                   //
// iHeight      : ι⤵ʲǿ                                 //
// iMaxValue    : βͤκ                                 //
//---------------------------------------------------------------------//
void WritePgm(int * piOutputData, int iWidth, int iHeight, int iMaxValue);

//---------------------------------------------------------------------//
// void WritePgm(int * piOutputData, int iWidth,                       //
//               int iHeight, int iResolution)                         //
//        : PGMեؽ񤭽Ф                                  //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2013. 9. 5   (Computer Vision Lab.)              //
//                                                                     //
// []                                                              //
// piInputData  : ([ǿ])PGMΥǡ                    //
//                ǿ=iWidth * iHeight                              //
// iWidth       : ʲǿ                                   //
// iHeight      : ι⤵ʲǿ                                 //
// iResolution  : β                                         //
//---------------------------------------------------------------------//
void WritePgm(int * piOutputData, int iWidth, int iHeight, int iResolution);

#endif
